#include <stdio.h>
#include <string.h>
#include <qdos.h>
#include <sys/socket.h>
#include "qsockets.h"
#include <errno.h>


static void domisc(int D0, int D1)
{
    REGS_t in,out;
    int res;
    int ch;

    if((ch = io_open("sck_", 0)) > 0)
    {
        in.D0 = D0;
        in.A0 = (addreg_t)ch;
        in.D1 = D1;
        in.D3 = -1;
        res = neterrno(in.A0, qdos3(&in, &out));
        io_close(ch);
    }
    else errno = EINVAL;
}

static void * getmisc(int D0, void *buf)
{
    void *ptr;
    REGS_t in,out;
    int res;
    int ch;

    if((ch = io_open("sck_", 0)) > 0)
    {
        in.D0 = D0;
        in.D3 = -1;
        in.A0 = (addreg_t)ch;
        in.A2 = (addreg_t)buf;    
        res = neterrno(in.A0, qdos3(&in, &out));
        ptr = (res < 0) ? NULL : buf;
        io_close(ch);
    }
    else
    {
        ptr = NULL;
        errno = EINVAL;
    }

    return ptr;
}

void sethostent(int stayopen)
{
    domisc(IP_SETHOSTENT, stayopen);
}

void endhostent(void)
{
    domisc(IP_ENDHOSTENT, 0);
}

void setprototent(int stayopen)
{
    domisc(IP_SETPROTOENT, stayopen);
}

struct servent *getservent(void)
{
    static char buf[DBUFSIZE];
    return (struct servent *)getmisc(IP_GETSERVENT, buf);
}

struct netent *getnetent(void)
{
    static char buf[DBUFSIZE];
    return (struct netent *)getmisc(IP_GETNETENT, buf);
}

struct protoent *getprotoent(void)
{
    static char buf[DBUFSIZE];
    return (struct protoent *)getmisc(IP_GETPROTOENT, buf);
}

void endprotoent(void)
{
    domisc(IP_ENDPROTOENT, 0);
}
void setservent(int stayopen)
{
    domisc(IP_SETSERVENT, stayopen);
}

void endservent(void)
{
    domisc(IP_ENDSERVENT, 0);
}

void setnetent(int stayopen)
{
    domisc(IP_SETNETENT, stayopen);
}

void endnetent(void)
{
    domisc(IP_ENDNETENT, 0);
}


int __h_errno(void)
{
    REGS_t in,out;
    int res;
    int ch, h;

    if((ch = io_open("sck_", 0)) > 0)
    {
        in.D0 = IP_H_ERRNO;
        in.A0 = (addreg_t)ch;
        in.D3 = -1;
        if((res = neterrno(in.A0, qdos3(&in, &out))) == 0)
        {
            h = out.D1;
        }
        io_close(ch);
    }
    else errno = EINVAL;
    return h;    
}

void __h_strerror(char *s)
{
    REGS_t in,out;
    int res;
    int ch;
    
    if((ch = io_open("sck_", 0)) > 0)
    {
        in.D0 = IP_H_STRERROR;
        in.A0 = (addreg_t)ch;
        in.A1 = s;
        in.D3 = -1;
        res = neterrno(in.A0, qdos3(&in, &out));
        io_close(ch);
    }
    else errno = EINVAL;
}


void herror(const char *s)
{
    int h;
    char buf[256];
    
    __h_strerror(buf);
    fputs(s, stderr);
    fputs(": ", stderr);
    fputs(buf, stderr);
    fputc('\n', stderr);
}


